{- decorate.p -}

data Tree a = Leaf a | Bin (Tree a) (Tree a);

decorate (Leaf a) xs = Leaf (a, head xs);
decorate (Bin s t) xs = Bin (decorate s xs) (decorate t (drop (size s) xs));

head (x:xs) = x;

fst (a,b) = a;
snd (a,b) = b;

drop 0 xs = xs;
drop (n+1) (x:xs) = drop n xs;

size (Leaf a) = 1;
size (Bin s t) = size s + size t;

TRANSFORM fastdec
REDEFINE decorate t xs = fst (dec t xs)
SPECIFYING dec t xs = split2 (\t xs -> decorate t xs)
                             (\t xs -> drop (size t) xs) 
                             (foldtree Leaf Bin t)
                             xs
USING
  DEFINITION decorate,size,(.),uncurry2;

  dropplus: drop (n+m) xs = drop m (drop n xs);

  fusion: split2 f g (foldtree start join x)
         =
         foldtree k (uncurry2 h) x,
      if { \ a -> split2 f g (start a)  = \ a -> k a; 
         \ x y -> split2 f g (join x y) =  \ x y  -> h (f x) (g x) (f y) (g y)};

  DEFINITION split2

END;

foldtree leaf bin (Leaf a) = leaf a;
foldtree leaf bin (Bin s t) = bin (foldtree leaf bin s) (foldtree leaf bin t);

split2 f g a b = (f a b,g a b);

uncurry2 e fg hk = e (fst.fg) (snd.fg) (fst.hk) (snd.hk);
