module AG1_Sem where
import UU_Maps

type Gram      = Map Nonterminal  Alts
type Alts      = Map Constructor  Alt
type Alt       = Map El_name    (Nonterminal, Sem_Funcs)
type Sem_Funcs = Map String String

type Nonterminal     = String
type Constructor     = String
type El_name         = String
type Attr_name       = String

type Attr_table      = Map Nonterminal [Attr_name]

sem_OldConid = id

sem_Elems_One_Elem (t1, t2, t3, t4) (upd1, upd2, upd3, upd4) 
                   = (upd1 t1, upd2 t2, upd3 t3, upd4 t4)
sem_Elems_No_Elem  = ([], [], [], [])
  
sem_Elem_Data    nt aaalts   = ((nt, []) <++ aaalts, ((nt, []) <++ id), ((nt, []) <++ id), id)
sem_Elem_Extend  nt aaalts   = ((nt    ) <-- aaalts, id, id, id)

sem_Alts alts                = applyall alts
sem_Alt constr_name aafields = 
    (constr_name, []) <++ ( aafields
                          . sem_Field "LOCAL" "local"
                          . sem_Field "LHS" "lhs"
                          )

sem_Fields fields    = applyall fields
sem_Field name nont  = ( (name, (nont,[])) <++ id)

addnames ntlist names = applyall (map (<--(applyall (map (:) names) )) ntlist)

sem_Nonterms = id
sem_Attrs    = id
sem_Nonterm  = id
--------------------------------------------------------------------
-- Semantic Functions for processing Semantic Function Dedinitions
--------------------------------------------------------------------

sem_Elem_Indef    ntlist names = (id, addnames ntlist names, id                   , id)
sem_Elem_Outdef   ntlist names = (id, id                   , addnames ntlist names, id)
sem_Elem_Inoutdef ntlist names = (id, addnames ntlist names, addnames ntlist names, id)

sem_Elem_Rules        :: String -> (Alts      -> Alts)     -> (Gram     -> Gram, a->a, b->b, c-> c)
sem_AltRule           :: String -> (Alt       -> Alt)       -> Alts      -> Alts
sem_FieldRule         :: String -> (Sem_Funcs -> Sem_Funcs) -> Alt       -> Alt 
sem_AttrRule          :: String -> String                  -> Sem_Funcs -> Sem_Funcs

sem_Attrs_One_Attr           = (:)
sem_Attrs_No_Attrs           = ([])
sem_AltRules_One_AltRule      = (.)
sem_AltRules_No_AltRules      = (id)
sem_FieldRules_One_FieldRule  = (.)
sem_FieldRules_No_FieldRules  = id
sem_AttrRules_One_AttrRule    = (.)
sem_AttrRules_No_AttrRules    = id

sem_Elem_Rules   ntname  altrules =  (ntname    <--  altrules, id, id , id)
sem_AltRule      altname elrules  =  altname    <--  elrules
sem_FieldRule    elname  atrules  =  elname     <--  \ (nt, funcs) -> (nt,  atrules funcs)
sem_AttrRule     attr    exp      =  (attr, "") <++  const exp
                       
{-
insert :: String -> [String] -> [String]
insert a [] = [a]
insert a (b:bs) | a <  b    = a:(b:bs)
                | a == b     = error ("Attemp to insert' twice: " ++ show a)
                | otherwise  = b:insert a bs 
-}